;;;
;;;     Universal Monitor for Panafacom MN1610
;;;

	CPU	MN1610

TARGET:	EQU	"MN1610"

	INCLUDE	"config.inc"

	INCLUDE "../common.inc"

;;;
;;; Zero page
;;;

	ORG	X'0000'

OPSW0:	DC	X'0000'
	DC	CSTART
OPSW1:	DC	X'0000'
	DC	CSTART
OPSW2:	DC	X'0000'
	DC	CSTART
OPSW3:	DC	X'0000'
	DC	CSTART

	ORG	ENTRY
	
C_CSTART:
	DC	CSTART
C_WSTART:
	DC	WSTART
C_CONOUT:
	DC	CONOUT
C_STROUT:
	DC	STROUT
C_CONIN:
	DC	CONIN
C_CONST:
	DC	CONST

C_ERR:
	DC	ERR
C_SKIPSP:
	DC	SKIPSP
C_UPPER:
	DC	UPPER
C_RDHEX:
	DC	RDHEX
C_GETLIN:
	DC	GETLIN
C_HEXOUT4:
	DC	HEXOUT4
C_CRLF:
	DC	CRLF

;;;
;;; ROM area
;;;

	ORG	X'0100'

NSPW0:	DC	X'0000'		; RESET / IRQ0
	DC	CSTART
NSPW1:	DC	X'0000'		; IRQ1
	DC	CSTART
NSPW2:	DC	X'0000'		; IRQ2
	DC	CSTART

INITSP:	DC	STACK
INITAD:	DC	X'0800'
OMSGA:	DC	OPNMSG
PROMPA:	DC	PROMPT
	
CSTART:
	L	SP,INITSP

	BAL	(INITA)

	L	R0,INITAD
	ST	R0,DSADDR
	ST	R0,SADDR
	ST	R0,GADDR
	MVI	R0,'I'
	ST	R0,HEXMOD

	;; Opening message
	L	X0,OMSGA
	BAL	(C_STROUT)

WSTART:	
	L	X0,PROMPA
	BAL	(C_STROUT)
	BAL	(C_GETLIN)
	EOR	X0,X0
	MVI	X0,INBUF
	BAL	(C_SKIPSP)
	BAL	(C_UPPER)
	MVB	R0,R0,NZ
	B	WSTART

	MVI	R1,'D'
	CB	R0,R1,NZ
	B	DUMP
	MVI	R1,'G'
	CB	R0,R1,NZ
	B	(GOA)
	MVI	R1,'S'
	CB	R0,R1,NZ
	B	(SETMA)
	
ERR:
	L	X0,ERRMA
	BAL	(C_STROUT)
	B	WSTART

ERRMA:	DC	ERRMSG
INITA:	DC	INIT
GOA:	DC	GO
SETMA:	DC	SETM
	
;;;
;;; Dump memory
;;; 
DUMP:
	AI	X0,1
	BAL	(C_SKIPSP)
	BAL	(C_RDHEX)	; 1st arg.
	MV	R2,R2,Z
	B	DP0
	;; No arg.
	BAL	(C_SKIPSP)
	MVB	R0,R0,Z
	B	ERR
	L	R0,DSADDR
	MVI	R1,64
	A	R0,R1
	ST	R0,DEADDR
	B	DPM

	;; 1st arg. found
DP0:
	ST	R4,DSADDR
	BAL	(C_SKIPSP)
	MVI	R1,','
	CB	R0,R1,NZ
	B	DP1
	EOR	R1,R1
	CB	R0,R1,Z
	B	ERR
	;; No 2nd arg.
	MVI	R1,64
	A	R4,R1
	ST	R4,DEADDR
	B	DPM
DP1:
	AI	X0,1
	BAL	(C_SKIPSP)
	BAL	(C_RDHEX)
	BAL	(C_SKIPSP)
	MV	R2,R2,NZ
	B	ERR
	EOR	R1,R1
	CB	R0,R1,Z
	B	ERR
	AI	R4,1
	ST	R4,DEADDR
DPM:	
	;; DUMP main
	L	X0,DSADDR
	L	R1,DPMC
	AND	X0,R1
	EOR	R1,R1
	ST	R1,DSTATE
DPM0:
	BAL	DPL
	BAL	(C_CONST)
	MVB	R0,R0,Z
	B	DPM1
	L	R0,DSTATE
	MVI	R1,2
	CB	R0,R1,LPZ
	B	DPM0
	L	X0,DEADDR
	ST	X0,DSADDR
	B	(C_WSTART)
DPM1:
	ST	X0,DSADDR
	BAL	(C_CONIN)
	B	(C_WSTART)
	
DPMC:	DC	X'FFF8'

DPL:
	;; DUMP	line
	MV	R0,X0
	BAL	(C_HEXOUT4)
	PUSH	X0
	L	X0,DPLC0
	BAL	(C_STROUT)
	POP	X0
	EOR	X1,X1
	MVI	X1,INBUF
	MVI	R2,8
DPL0:
	BAL	DPB
	SI	R2,1,Z
	B	DPL0

	PUSH	X0
	L	X0,DPLC1
	BAL	STROUT

	EOR	X0,X0
	MVI	X0,INBUF
	MVI	R2,8
DPL1:
	L	R0,0(X0)
	BSWP	R0,R0
	BAL	DPC
	L	R0,0(X0)
	BAL	DPC
	AI	X0,1
	SI	R2,1,Z
	B	DPL1
	POP	X0
	B	(C_CRLF)
	
DPLC0:	DC	DSEP0
DPLC1:	DC	DSEP1

DPB:
	;; DUMP byte
	MVI	R0,' '
	BAL	(C_CONOUT)
	L	R0,DSTATE
	MV	R0,R0,Z
	B	DPB2
	;; Dump state 0
	L	R0,DSADDR
	C	X0,R0,NZ
	B	DPB1
DPB0:
	;; Still 0 or 2
	MVI	R0,' '
	ST	R0,0(X1)
	PUSH	X0
	L	X0,DPBC2
	BAL	STROUT
	POP	X0
	AI	X0,1
	AI	X1,1
	RET
DPB1:
	;; Found start address
	MVI	R1,1
	ST	R1,DSTATE
DPB2:
	L	R0,DSTATE
	MVI	R1,1
	C	R0,R1,Z
	B	DPB0
	;; Dump state 1
	L	R0,0(X0)
	ST	R0,0(X1)
	BAL	HEXOUT4
	AI	X0,1
	AI	X1,1
	L	R0,DEADDR
	C	X0,R0,Z
	RET
	;; Found end address
	MVI	R0,2
	ST	R0,DSTATE
	RET
DPBC2:	DC	DSEP2

DPC:
	MVI	R1,' '
	CB	R0,R1,LPZ
	B	DPC0
	MVI	R1,X'7F'
	CB	R0,R1,LM
	B	DPC0
	B	(C_CONOUT)
DPC0:
	MVI	R0,'.'
	B	(C_CONOUT)

;;;
;;; GO address
;;;
GO:
	AI	X0,1
	BAL	(C_SKIPSP)
	BAL	(C_RDHEX)
	L	R0,0(X0)
	MVB	R0,R0,Z
	B	(C_ERR)
	MV	R2,R2,NZ
	B	G0
	ST	R4,GADDR
G0:
	L	X1,GADDR
	B	0(X1)

;;;
;;; SET memory
;;;
SETM:
	AI	X0,1
	BAL	(C_SKIPSP)
	BAL	(C_RDHEX)
	BAL	(C_SKIPSP)
	L	R0,0(X0)
	MVB	R0,R0,Z
	B	(C_ERR)
	MV	R2,R2,Z
	B	SM0
	L	R4,SADDR
SM0:
SM1:
	MV	R0,X1
	BAL	HEXOUT4
	L	X0,DPLC0
	BAL	STROUT
	L	R0,0(X1)
	BAL	HEXOUT4
	MVI	R0,' '
	BAL	(C_CONOUT)
	BAL	GETLIN
	MVI	X0,INBUF
	BAL	SKIPSP
	L	R0,0(X0)
	EOR	R1,R1
	CB	R0,R1,Z
	B	SM2
	;; Empty (Increment address)
	AI	X1,1
	ST	X1,SADDR
	B	SM1
SM2:
	MVI	R1,'-'
	CB	R0,R1,Z
	B	SM3
	;; '-' (Decrement address)
	SI	X1,1
	ST	X1,SADDR
	B	SM1
SM3:
	MVI	R1,'.'
	CB	R0,R1,Z
	B	SM4
	;; '.'  (Quit)
	ST	X1,SADDR
	B	(C_WSTART)
SM4:
	ST	X1,SADDR
	BAL	RDHEX
	MV	R2,R2,NZ
	B	(C_ERR)
	L	X0,SADDR
	ST	R4,0(X0)
	AI	X0,1
	ST	X0,SADDR
	MV	X1,X0
	B	SM1

;;;
;;; Other support routines
;;; 
	
STROUT:
	L	R0,0(X0)
	BSWP	R0,R0	
	L	R1,SOUTC
	AND	R0,R1,NZ
	B	SOUTR
	BAL	(C_CONOUT)
	L	R0,0(X0)
	L	R1,SOUTC
	AND	R0,R1,NZ
	B	SOUTR
	BAL	(C_CONOUT)
	AI	X0,1
	B	STROUT
SOUTR:
	RET
SOUTC:	DC	X'00FF'

HEXOUT4:
	PUSH	R0
	BSWP	R0,R0
	BAL	HEXOUT2
	POP	R0
HEXOUT2:
	PUSH	R0
	SR	R0,RE
	SR	R0,RE
	SR	R0,RE
	SR	R0,RE
	BAL	HEXOUT1
	POP	R0
HEXOUT1:
	MVI	R1,X'0F'
	AND	R0,R1
	MVI	R1,'0'
	A	R0,R1
	MVI	R1,'9'
	CB	R0,R1,LP
	B	(C_CONOUT)
	MVI	R1,'A'-'9'-1
	A	R0,R1
	B	(C_CONOUT)

CRLF:
	MVI	R0,CR
	BAL	(C_CONOUT)
	MVI	R0,LF
	B	(C_CONOUT)

GETLIN:
	EOR	X0,X0
	MVI	X0,INBUF
	EOR	R2,R2
GL0:
	BAL	(C_CONIN)
	MVI	R1,CR
	CB	R0,R1,NZ
	B	GLE
	MVI	R1,LF
	CB	R0,R1,NZ
	B	GLE
	MVI	R1,BS
	CB	R0,R1,NZ
	B	GLB
	MVI	R1,DEL
	CB	R0,R1,NZ
	B	GLB
	MVI	R1,' '
	CB	R0,R1,LPZ
	B	GL0
	MVI	R1,X'80'
	CB	R0,R1,LM
	B	GL0
	MVI	R1,BUFLEN-1
	CB	R2,R1,LM
	B	GL0		; Too long
	L	R1,SOUTC
	AND	R0,R1
	ST	R0,0(X0)
	AI	X0,1
	BAL	(C_CONOUT)
	AI	R2,1
	B	GL0
GLB:
	MVB	R2,R2,NZ
	B	GL0
	SI	R2,1
	SI	X0,1
	MVI	R0,BS
	BAL	(C_CONOUT)
	MVI	R0,' '
	BAL	(C_CONOUT)
	MVI	R0,BS
	BAL	(C_CONOUT)
	B	GL0
GLE:
	BAL	CRLF
	MVI	R0,0
	ST	R0,0(X0)
	RET

SKIPSP:
	L	R0,0(X0)
	AI	X0,1
	MVI	R1,' '
	CB	R0,R1,NZ
	B	SKIPSP
	SI	X0,1
	RET

UPPER:
	MVI	R1,'a'
	CB	R0,R1,LPZ
	B	UPR
	MVI	R1,'z'+1
	CB	R0,R1,LM
	B	UPR
	MVI	R1,'a'-'A'
	S	R0,R1
UPR:
	RET

RDHEX:
	EOR	R2,R2
	EOR	R4,R4
RH0:
	L	R0,0(X0)
	BAL	UPPER
	MVI	R1,'0'
	CB	R0,R1,LPZ
	B	RHE
	MVI	R1,'9'
	CB	R0,R1,LP
	B	RH1
	MVI	R1,'A'
	CB	R0,R1,LPZ
	B	RHE
	MVI	R1,'F'
	CB	R0,R1,LMZ
	B	RHE
	MVI	R1,'A'-'9'-1
	S	R0,R1
RH1:
	MVI	R1,'0'
	S	R0,R1
	SL	R4,RE
	SL	R4,RE
	SL	R4,RE
	SL	R4,RE
	A	R4,R0
	AI	X0,1
	AI	R2,1
	B	RH0
RHE:
	RET

;;;
;;; Data area
;;;

OPNMSG:
        DC      "\r\nUniversal Monitor MN1610\r\n\0"
PROMPT:
	DC	"] \0"
IHEMSG:
	DC	"Error ihex\r\n\0"
SHEMSG:
	DC	"Error srec\r\n\0"
ERRMSG:
	DC	"Error\r\n\0"
DSEP0:
	DC	" :\0"
DSEP1:
	DC	" : \0"
DSEP2:
	DC	"    \0"
	
	IF USE_DEV_EMILY
	INCLUDE	"dev/dev_emily.asm"
	ENDIF

;;;
;;; RAM area
;;;

	;;
	;; Work	Area
	;;

	ORG	WORK_B

INBUF:	DS	BUFLEN		; Line input buffer
DSADDR:	DS	1		; Dump start address
DEADDR:	DS	1		; Dump end address
DSTATE:	DS	1		; Dump state
GADDR:	DS	1		; Go address
SADDR:	DS	1 		; Set address
HEXMOD:	DS	1		; HEX file mode
RECTYP:	DS	1		; Record type

	END

